function grad = get_grad(W, X, Y, sample)
% Compute the gradient of the multinomial logistic loss at W.
%   X: feature vectors
%   Y: labels
%   sample: examples used to compute the gradient
    
    grad = zeros(size(W));
    
    for i = sample        
        x = X(i,:)';
        y = Y(i);

        p = exp(W * x);
        p = p / sum(p);
        p(y) = p(y) - 1;        
        grad = grad + p * x';
    end

    grad = grad / length(sample);
end

